dnl checks for frost symbol prefix

AC_DEFUN(LOC_SYM_PREFIX, [
enableval="__frost__"
AC_MSG_CHECKING(for frost symbol prefix)
AC_ARG_ENABLE(sym-prefix,[  --enable-sym-prefix=fp  frost symbol prefix])
AC_MSG_RESULT($enableval)
case "$enableval" in
	yes|no)
		echo
		echo "*** you must specify the symbol prefix"
		echo
		exit 1
		;;
esac
AC_DEFINE_UNQUOTED(SYM_PREFIX,"$enableval",[frost symbol prefix])
])

dnl checks for default library include paths

AC_DEFUN(LOC_LIB_PATHS, [
AC_MSG_CHECKING(for default library paths)

echo 'int main() { return 0; }' > conftest.cc
loc_lib_paths=""

loc_lib_paths=$(
g++ -v conftest.cc -o conftest 2>&1 | tail -n 1 | while read -d ' ' w
do
	echo $w
done | grep -- -L | sed 's/-L//' | while read l
do
	echo -n "$l "
done
)

AC_DEFINE_UNQUOTED(LIB_PATHS,"$loc_lib_paths",[library paths])

rm -f conftest.cc conftest
])

dnl checks for flex flags

AC_DEFUN(LOC_CHECK_FLEX_FLAGS, [
AC_REQUIRE([UDS_CHECK_FLEX_FLAGS])

if test -z "$FLEX_FLAGS" && test -z "$loc_scsh" -o -z "$loc_flex"
then
	echo
	echo "*** flex and scsh must be installed to regenerate lexer files."
	echo "*** use --enable-fast-lexer if necessary."
	echo
	exit 1
fi
])

dnl print an error message and abort

AC_DEFUN(LOC_ABORT, [

echo
echo "*** $1 must be properly installed to build frost."
echo "*** Please check config.log."
echo
exit 1
])
