/*
 * Frost - use C++ multi methods as if they were a native feature
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include "ascode.hh"
#include "dthunk.hh"


// DispThunk implementation

DispThunk::DispThunk( const string& n, const string& t ) :
	DispBase( n ), func( t )
{
}

DispThunk::~DispThunk()
{
}

ostream&
DispThunk::EmitCode( ostream& out ) const
{
	out<<endl;
	
	DefineFunction( out, Name(), false );

	for ( size_t i = 0; i < TP_Adj().size(); ++i )
	{
		size_t so = TP_Adj()[i].first;
		size_t dt = TP_Adj()[i].second;
		
		// adjust 'this' pointer
		AdjustThis( out, so, dt, false );
	}
		
	// jump to target function
	Jump( out, func );
	
	return out;
}
