/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _frost_dthunk_hh
#define _frost_dthunk_hh


// includes

#include "dbase.hh"


/** represents a dispatcher thunk function
	\author Julian v. Bock */
class DispThunk : public DispBase
{
public:
	/** \param n dispatcher thunk name
		\param t target function name */
	DispThunk( const string& n, const string& t );
	
	/** destructor */
	virtual
	~DispThunk();
	
	/** prints the dispatcher assembly code
		\param out output stream
		\return output stream */
	virtual ostream&
	EmitCode( ostream& out ) const;

	/** \return if the dispatcher is global */
	virtual bool
	Global() const { return false; }
	
private:
	/// target function name
	string	func;
};

#endif // _frost_dthunk_hh
