/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _frost_sio_hh
#define _frost_sio_hh


// includes

#include <uds/action.hh>
#include <iostream>
#include <string>

using namespace std;
using namespace uds;


/** list marker class */
class ListMarker
{
public:
	/** \param _in input stream */
	ListMarker( istream& _in );

	/** destructor */
	~ListMarker();

private:
	/// input stream
	istream& in;
};


/** reads a quoted string from an input stream
	\param in input stream
	\return string */
string
ReadQStr( istream& in );

/** reads a boolean from an input stream
	\param in input stream
	\return bool */
bool
ReadBool( istream& in );

/** reads a list from an input stream. A function object is executed until
	the end of the list is reached.
	\param in input stream
	\param ac action
	\param ms magic string */
void
WalkList( istream& in, const AnyAction& ac, const string& ms = "" );

/** skips an (already opened) list.
	\param in input stream */
void
SkipList( istream& in );

#endif // _frost_sio_hh
