/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _frost_titable_hh
#define _frost_titable_hh


// includes

#include "vtibase.hh"

using namespace std;


class VTable;


/** typeinfo table class
	\author Julian v. Bock */
class TITable : public vti_base
{
public:
	/** \param n encoded typeinfo table name
		\param vt associated virtual table */
	TITable( const string& n, VTable& vt );

	/** destructor */
	virtual
	~TITable();

	/** assigns a value to a typeinfo table slot
		\param s typeinfo table slot
		\param v value */
	virtual void
	Assign( size_t s, const string& v );

	/** adds raw data to the typeinfo table
		\param v value */
	virtual void
	Fill( int v );

	/** print the assembler representation of the typeinfo table to an output
		stream
		\param out output stream */
	virtual void
	EmitCode( ostream& out ) const;
};

#endif // _frost_titable_hh
