/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  (See file COPYING for more information)
 */


// includes

#include <iostream>

using namespace std;


class base1
{
public:
	virtual
	~base1() {}
};


class base2
{
public:
	virtual
	~base2() {}
};


class multi : public base1, public base2
{
public:
	virtual
	~multi() {}
};


void
func( virtual base1& )
{
	cout<<"base1\n";
}

void
func( virtual base2& )
{
	cout<<"base2\n";
}

void
func( virtual multi& )
{
	cout<<"multi\n";
}


int
main()
{
	base1		bas1;
	base2		bas2;
	multi		mul;
	base1&		mul1 = mul;
	base2&		mul2 = mul;

	func( bas1 );
	func( bas2 );
	func( mul );
	func( mul1 );
	func( mul2 );

	return 0;
}
